// Garden Gnome Software - Skin
// Pano2VR 6.0.4/17320
// Filename: Zoom-Floorplan.ggsk
// Generated 2019-06-23T12:19:10

function pano2vrSkin(player,base) {
	player.addVariable('plan_status', 2, false);
	var me=this;
	var skin=this;
	var flag=false;
	var skinKeyPressed = 0;
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	this.ggUserdata=player.userdata;
	this.lastSize={ w: -1,h: -1 };
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=[];
	this.elementMouseOver=[];
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	var hs,el,els,elo,ela,elHorScrollFg,elHorScrollBg,elVertScrollFg,elVertScrollBg,elCornerBg;
	if (typeof document.body.style['transform'] == 'undefined') {
		for(var i=0;i<prefixes.length;i++) {
			if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
				cssPrefix='-' + prefixes[i].toLowerCase() + '-';
				domTransition=prefixes[i] + 'Transition';
				domTransform=prefixes[i] + 'Transform';
			}
		}
	}
	
	player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=[];
		stack.push(startElement);
		while(stack.length>0) {
			var e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	this.callNodeChange=function(startElement) {
		var stack=[];
		stack.push(startElement);
		while(stack.length>0) {
			var e=stack.pop();
			if (e.ggNodeChange) {
				e.ggNodeChange();
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	player.addListener('configloaded', function() { me.callNodeChange(me.divSkin); });
	player.addListener('changenode', function() { me.ggUserdata=player.userdata; me.callNodeChange(me.divSkin); });
	
	var parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=[];
		var stack=[];
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			var e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		var hs='';
		this.ggCurrentTime=new Date().getTime();
		el=me._floorplan=document.createElement('div');
		el.ggFilter = '';
		el.ggFilteredIds = [];
		el.ggId="Floorplan";
		el.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		el.ggVisible=true;
		el.className="ggskin ggskin_map ";
		el.ggType='map';
		hs ='';
		hs+=cssPrefix + 'background-clip : padding-box;';
		hs+='background-clip : padding-box;';
		hs+='background : #ffffff;';
		hs+='border : 1px solid rgba(255,117,244,0);';
		hs+='cursor : default;';
		hs+='height : 40%;';
		hs+='left : 16px;';
		hs+='overflow : hidden;';
		hs+='position : absolute;';
		hs+='top : 16px;';
		hs+='visibility : inherit;';
		hs+='width : 30%;';
		hs+='pointer-events:auto;';
		el.setAttribute('style',hs);
		el.style[domTransform + 'Origin']='0% 0%';
		me._floorplan.ggIsActive=function() {
			return false;
		}
		el.ggElementNodeId=function() {
			return player.getCurrentNode();
		}
		me._floorplan.ggUpdateConditionResize=function () {
			var mapDetails = player.getMapDetails(me._floorplan.ggMapId);
			if (!(mapDetails.hasOwnProperty('title'))) return;
			me._floorplan.ggCalculateFloorplanSize(mapDetails);
			me._floorplan.ggShowSimpleFloorplan(mapDetails);
			me._floorplan.ggPlaceMarkersOnSimpleFloorplan();
			me._floorplan.ggRadar.update();
		}
		me._floorplan.ggUpdateConditionTimer=function () {
			me._floorplan.ggRadar.update();
		}
		me._floorplan.ggUpdatePosition=function (useTransition) {
			me._floorplan.ggUpdateConditionResize();
		}
		me._floorplan.ggNodeChange=function () {
			var mapDetails = player.getMapDetails(me._floorplan.ggMapId);
			if (!(mapDetails.hasOwnProperty('title'))) return;
			me._floorplan.ggCalculateFloorplanSize(mapDetails);
			me._floorplan.ggShowSimpleFloorplan(mapDetails);
			me._floorplan.ggPlaceMarkersOnSimpleFloorplan();
			me._floorplan.ggRadar.update();
			if (me._floorplan.ggLastNodeId) {
				var lastActiveMarker = me._floorplan.ggSimpleFloorplanMarkerArray[me._floorplan.ggLastNodeId];
				if (lastActiveMarker && lastActiveMarker.ggDeactivate) lastActiveMarker.ggDeactivate();
			}
			var id = player.getCurrentNode();
			var marker = me._floorplan.ggSimpleFloorplanMarkerArray[id];
			if (marker) {
				if (marker.ggActivate) marker.ggActivate();
			}
			if (player.getMapType(me._floorplan.ggMapId) == 'file') {
				var coords = player.getNodeMapCoords(id, me._floorplan.ggMapId);
				if (coords.length < 2) {
					var mapId = player.getMapContainingNode(id);
					if (mapId != '') {
							me._floorplan.ggChangeMap(mapId);
					}
				}
			}
			me._floorplan.ggLastNodeId = id;
		}
		me.divSkin.appendChild(me._floorplan);
		me._floorplan.ggMarkerInstances=[];
		me._floorplan.ggMapId = 'FloorPlan01';
		me._floorplan.ggLastNodeId=null;
		me._floorplan.ggSimpleFloorplanMarkerArray=[];
		me._floorplan.ggFloorplanWidth=0;
		me._floorplan.ggFloorplanHeight=0;
		me._floorplan__mapdiv=document.createElement('div');
		me._floorplan__mapdiv.className='ggskin ggskin_map';
		me._floorplan.appendChild(me._floorplan__mapdiv);
		me._floorplan__img=document.createElement('img');
		me._floorplan__img.className='ggskin ggskin_map';
		me._floorplan__mapdiv.appendChild(me._floorplan__img);
		me._floorplan.ggRadar={ lastFov : -1, lastPan : -1, xPos : -1, yPos : -1, radarElement : null }
		me._floorplan.ggRadar.update=function() {
			var radar=me._floorplan.ggRadar;
			var d2r = Math.PI/180 ;
			var fov = player.getFov();
			var pan = player.getPanNorth();
			pan -= me._floorplan.ggFloorplanNorth;
			var filterpassed = true;
			var currentId = player.getCurrentNode();
			if (me._floorplan.ggFilteredIds.length > 0 && me._floorplan.ggFilteredIds.indexOf(currentId) == -1) filterpassed = false;
			if ((me._floorplan.ggSimpleFloorplanMarkerArray.hasOwnProperty(currentId)) && filterpassed) {
				var activeMarker = me._floorplan.ggSimpleFloorplanMarkerArray[currentId];
				if ((radar.radarElement) && (fov==radar.lastFov) && (pan==radar.lastPan) && (activeMarker.radarXPos==radar.xPos) && (activeMarker.radarYPos==radar.yPos)) return; 
				radar.lastPan=pan; radar.lastFov=fov;
				radar.xPos=activeMarker.radarXPos; radar.yPos=activeMarker.radarYPos;
				if (radar.radarElement) me._floorplan__mapdiv.removeChild(radar.radarElement);
				radar.radarElement = document.createElementNS('http://www.w3.org/2000/svg','svg');
				radar.radarElement.setAttributeNS(null,'width',360);
				radar.radarElement.setAttributeNS(null,'height',360);
				radar.radarElement.setAttributeNS(null,'viewBox','0 0 360 360');
				var radarPath = document.createElementNS('http://www.w3.org/2000/svg','path');
				radarPath.setAttributeNS(null,'id','radarPath');
				pan = -90 - pan;
				var arcX1 = 180 * Math.cos((pan - fov / 2) * d2r);
				var arcY1 = 180 * Math.sin((pan - fov / 2) * d2r);
				var arcX2 = 180 * Math.cos((pan + fov / 2) * d2r);
				var arcY2 = 180 * Math.sin((pan + fov / 2) * d2r);
				arcX1 += 180;
				arcY1 += 180;
				arcX2 += 180;
				arcY2 += 180;
				var radarPathString = 'M180,180 L' + arcX1 + ',' + arcY1 + ' A 180 180 0 0 1 ' + arcX2 + ' ' + arcY2 +' Z';
				radarPath.setAttributeNS(null,'d', radarPathString);
				radarPath.setAttributeNS(null,'fill', '#ff0000');
				radarPath.setAttributeNS(null,'fill-opacity', 0.35);
				radarPath.setAttributeNS(null,'stroke', '#ff0000');
				radarPath.setAttributeNS(null,'stroke-opacity', 0.8);
				radarPath.setAttributeNS(null,'stroke-width', 1);
				radarPath.setAttributeNS(null,'stroke-linejoin', 'miter');
				radar.radarElement.appendChild(radarPath);
				me._floorplan__mapdiv.appendChild(radar.radarElement);
				var radarXPos = activeMarker.radarXPos - 180;
				var radarYPos = activeMarker.radarYPos - 180;
				radar.radarElement.style['position'] = 'absolute';
				radar.radarElement.style['left'] = '' + radarXPos + 'px';
				radar.radarElement.style['top'] = '' + radarYPos + 'px';
				radar.radarElement.style['z-index'] = me._floorplan.style['z-index'] + 1;
			} else {
				if (radar.radarElement) {
					me._floorplan__mapdiv.removeChild(radar.radarElement);
					radar.radarElement = null;
				}
			}
		}
		me._floorplan.ggShowSimpleFloorplan=function(mapDetails) {
			var mapWidth = me._floorplan.clientWidth;
			var mapHeight = me._floorplan.clientHeight;
			var levelLimit = 500;
			var level = 1;
			while (mapWidth > levelLimit && mapHeight > levelLimit) {
				levelLimit *= 2;
				level++;
			}
			var imageFilename = basePath + 'images/maptiles/' + me._floorplan.ggMapId + '_' + level + '.' + mapDetails['tileformat'];
			me._floorplan__img.setAttribute('src', imageFilename);
		me._floorplan__mapdiv.setAttribute('style','position: absolute; left: 0px; top: 0px;width:' + me._floorplan.ggFloorplanWidth + 'px;height:' + me._floorplan.ggFloorplanHeight + 'px;overflow:hidden;;');
		me._floorplan__img.setAttribute('style','width:' + me._floorplan.ggFloorplanWidth + 'px;height:' + me._floorplan.ggFloorplanHeight + 'px;-webkit-user-drag:none;pointer-events:none;');
		}
		me._floorplan.ggCalculateFloorplanSize=function(mapDetails) {
			var floorplanWidth = mapDetails['width'];
			var floorplanHeight = mapDetails['height'];
			var frameAR = me._floorplan.clientWidth / me._floorplan.clientHeight;
			var floorplanAR = floorplanWidth / floorplanHeight;
			if (frameAR > floorplanAR) {
				me._floorplan.ggFloorplanHeight = me._floorplan.clientHeight;
				me._floorplan.ggFloorplanWidth = me._floorplan.ggFloorplanHeight * floorplanAR;
			} else {
				me._floorplan.ggFloorplanWidth = me._floorplan.clientWidth;
				me._floorplan.ggFloorplanHeight = me._floorplan.ggFloorplanWidth / floorplanAR;
			}
		}
		me._floorplan.ggInitMap=function() {
			me._floorplan.ggMapNotLoaded = false;
			var mapDetails = player.getMapDetails(me._floorplan.ggMapId);
			me._floorplan.style.backgroundColor = mapDetails['bgcolor'];
			if (mapDetails.hasOwnProperty('transparent') && mapDetails['transparent']) {
				me._floorplan.ggPermeableMap = true;
			} else {
				me._floorplan.ggPermeableMap = false;
			}
			me._floorplan.ggCalculateFloorplanSize(mapDetails);
			me._floorplan.ggShowSimpleFloorplan(mapDetails);
			me._floorplan.ggFloorplanNorth = mapDetails['floorplannorth'];
		}
		me._floorplan.ggClearMap=function() {
			me._floorplan.ggClearMapMarkers();
			me._floorplan.ggMapNotLoaded = true;
		}
		me._floorplan.ggChangeMap=function(mapId) {
			var newMapType = player.getMapType(mapId)
			if (newMapType == 'web') {
				return;
			}
			me._floorplan.ggMapId = mapId;
			me._floorplan.ggClearMap();
			me._floorplan.ggInitMap();
			me._floorplan.ggInitMapMarkers();
		}
		me._floorplan.ggPlaceMarkersOnSimpleFloorplan=function() {
			var markers=me._floorplan.ggSimpleFloorplanMarkerArray;
			for (id in markers) {
				if (markers.hasOwnProperty(id)) {
					marker=markers[id];
					var coords = player.getNodeMapCoordsInPercent(id, me._floorplan.ggMapId);
					var xPos = (me._floorplan.ggFloorplanWidth * coords[0]) / 100.0;
					var yPos = (me._floorplan.ggFloorplanHeight * coords[1]) / 100.0;
					marker.radarXPos = xPos;
					marker.radarYPos = yPos;
					xPos -= me._floorplan.ggHMarkerAnchorOffset;
					yPos -= me._floorplan.ggVMarkerAnchorOffset;
					marker.style['position'] = 'absolute';
					marker.style['left'] = xPos + 'px';
					marker.style['top'] = yPos + 'px';
					marker.style['z-index'] = me._floorplan.style['z-index'] + 2;
				}
			}
		}
		me._floorplan.ggInitMapMarkers=function() {
			me._floorplan.ggClearMapMarkers();
			var ids = player.getNodeIds();
			me._floorplan.ggFilteredIds = [];
			if (me._floorplan.ggFilter != '') {
				var filter = me._floorplan.ggFilter.split(',');
				for (i=0; i < ids.length; i++) {
					var nodeId = ids[i];
					var nodeData = player.getNodeUserdata(nodeId);
					for (var j=0; j < filter.length; j++) {
						if (nodeData['tags'].indexOf(filter[j].trim()) != -1) me._floorplan.ggFilteredIds.push(nodeId);
					}
				}
				if (me._floorplan.ggFilteredIds.length > 0) ids = me._floorplan.ggFilteredIds;
			}
			for(var i=0; i < ids.length; i++) {
				var id = ids[i];
				var coords = player.getNodeMapCoordsInPercent(id, me._floorplan.ggMapId);
				if (coords.length>=2) {
					me._floorplan.ggHMarkerAnchorOffset = 8;
					me._floorplan.ggVMarkerAnchorOffset = 8;
					var markerParent = new Object();
					markerParent.ggElementNodeId=function() { return id };
					var markerClass = new SkinElement_floorplanmarker_Class(me, markerParent);
					me._floorplan.ggMarkerInstances.push(markerClass);
					var marker = markerClass._floorplanmarker;
					me._floorplan.ggSimpleFloorplanMarkerArray[id] = marker;
					me._floorplan__mapdiv.appendChild(marker);
				}
			}
			me._floorplan.ggPlaceMarkersOnSimpleFloorplan();
			skin.updateSize(me._floorplan);
		}
		me._floorplan.ggClearMapMarkers=function() {
			for (id in me._floorplan.ggSimpleFloorplanMarkerArray) {
				if (me._floorplan.ggSimpleFloorplanMarkerArray.hasOwnProperty(id)) {
					me._floorplan__mapdiv.removeChild(me._floorplan.ggSimpleFloorplanMarkerArray[id]);
				}
			}
			me._floorplan.ggMarkerInstances=[];
			me._floorplan.ggSimpleFloorplanMarkerArray=[];
		}
		player.addListener('sizechanged', function() {
			me.updateSize(me.divSkin);
		});
		player.addListener('configloaded', function() {
			me._floorplan.ggInitMap(false);
			me._floorplan.ggInitMapMarkers(true);
		});
	};
	this.hotspotProxyClick=function(id, url) {
	}
	this.hotspotProxyDoubleClick=function(id, url) {
	}
	me.hotspotProxyOver=function(id, url) {
	}
	me.hotspotProxyOut=function(id, url) {
	}
	player.addListener('changenode', function() {
		me.ggUserdata=player.userdata;
	});
	me.skinTimerEvent=function() {
		me.ggCurrentTime=new Date().getTime();
		me._floorplan.ggUpdateConditionTimer();
	};
	player.addListener('timer', me.skinTimerEvent);
	function SkinElement_floorplanmarker_Class(parentScope,ggParent) {
		var me=this;
		var flag=false;
		me.parentScope=parentScope;
		me.ggParent=ggParent;
		var nodeId=ggParent.ggElementNodeId();
		me.ggNodeId=nodeId;
		me.ggUserdata=skin.player.getNodeUserdata(nodeId);
		me.elementMouseDown=[];
		me.elementMouseOver=[];
		
		me.findElements=function(id,regex) {
			return skin.findElements(id,regex);
		}
		
		el=me._floorplanmarker=document.createElement('div');
		el.ggId="Floorplan-Marker";
		el.ggDx=-246;
		el.ggDy=18;
		el.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		el.ggVisible=true;
		el.className="ggskin ggskin_rectangle ";
		el.ggType='rectangle';
		hs ='';
		hs+=cssPrefix + 'border-radius : 99px;';
		hs+='border-radius : 99px;';
		hs+='background : #fdadb0;';
		hs+='border : 1px solid #f82d2c;';
		hs+='cursor : pointer;';
		hs+='height : 15px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 15px;';
		hs+='pointer-events:auto;';
		el.setAttribute('style',hs);
		el.style[domTransform + 'Origin']='50% 50%';
		me._floorplanmarker.ggIsActive=function() {
			return player.getCurrentNode()==this.ggElementNodeId();
		}
		el.ggElementNodeId=function() {
			return me.ggNodeId;
		}
		me._floorplanmarker.onclick=function (e) {
			player.openNext("{"+me.ggNodeId+"}","");
		}
		me._floorplanmarker.ggUpdatePosition=function (useTransition) {
		}
	};
	me.addSkin();
	me.skinTimerEvent();
};